<?php

/**
  * Ping-servise for admin panel, AdminPingomatic.php
  * @category admin
  *
  * @author ramzes_ra <admin@esculap.in>
  * @copyright ramzes_ra
  * @license http://www.opensource.org/licenses/osl-3.0.php Open-source licence 3.0
  * @version 1.3
 */

include_once(PS_ADMIN_DIR.'/../classes/AdminTab.php');

class AdminPingomatic extends AdminTab
	
{	    
	public function __construct()
	{
	$this->_pingservers= array();
	$this->_done = array();
    $this->allow = '';
  	parent::__construct();
	}

    public function display()
	{
		global $currentIndex,$cookie;
        $this->_done = explode(',',Configuration::get('PING_DONE'));
       	$product_name = Db::getInstance()->ExecuteS('SELECT `id_product`,`name`
		FROM `'._DB_PREFIX_.'product_lang` WHERE `id_lang` = '.intval($cookie->id_lang));
		echo '<form action="'.$currentIndex.'&token='.$this->token.'" method="post">
			<fieldset>
			<legend><img src="../img/t/AdminPingomatic.gif" />'.$this->l('Send ping').'</legend>
					<span>'.$this->l('Click Ping-button for ping').'.</span><br /><br />
					<table cellspacing="0" cellpadding="0" class="table" style="width: 29.5em;">
							<thead>	
								<tr>
				                    <th>'.$this->l('Ping').'</th>
									<th>'.$this->l('Product').'</th>
								</tr>
							</thead>
							<tbody>';
	
		foreach($product_name AS $row)
			if (!in_array (intval($row['id_product']), $this->_done))
			{
			echo'<tr><td> 
			<input type="submit" class="button" value="'.intval($row['id_product']).'" name="submitPing" ></td><td>'.$row['name'].'</td></tr>';
		    }
		    echo'
							</tbody>
					</table>
			</fieldset>
			   </form>
				<br /><br />
		<form action="'.$currentIndex.'&token='.$this->token.'" method="post" class="width3">
		  <fieldset>
			 <legend><img src="../img/t/AdminPingomatic.gif" />'.$this->l('Ping Servers').'</legend>
			<table cellspacing="0" cellpadding="0" class="table" style="width: 29.5em;">
										<tr>
				<span>'.$this->l('Input name new Ping Server').'...</span><br />
       	<input type="textarea" class="textarea" value="" name="newServer" style="width: 29.5em;"></tr><br />
       						';
			
       foreach($this->_pingservers AS $server)
       	   echo'<tr><td>
       	<input type="radio" class="radio" value="'.$server.'" name="radioDel" ></td><td>'.$server.'</td></tr>';
		   echo'	<div >
					<input type="submit" value="'.$this->l('Addition Server').'" name="submitAdd" class="button" />
				                
				   <input type="submit" value="'.$this->l('Deletion Server').'" name="submitDel" class="button" />
				        </div><br />
				  <span>'.$this->l('...or click on radio for deletion').'.</span><br />         
			</table>
		  </fieldset>
		</form>';
	}

	public function postProcess()
	{
		global $currentIndex,$cookie;
		 $_pinglist = Configuration::get('PING_SERVERS');
	  if(substr_count($_pinglist, "\n")>0){
			$this->_pingservers=explode("\n",$_pinglist);
		}else{
			$this->_pingservers[0]=$_pinglist;
		}
      if (isset($_POST['submitAdd']) AND Tools::getValue('newServer'))
         {
         	$newS = $_pinglist."\n".Tools::getValue('newServer');
          	Configuration::updateValue('PING_SERVERS', $newS);
            Tools::redirectAdmin($currentIndex.'&token='.$this->token);
            }

      if (isset($_POST['submitDel']) AND Tools::getValue('radioDel'))
        {
            $delS = Tools::getValue('radioDel');
            $_pinglist = str_replace($delS."\n",'',$_pinglist);
            Configuration::updateValue('PING_SERVERS', $_pinglist);
            Tools::redirectAdmin($currentIndex.'&token='.$this->token);
           }
         
      if ($_pVal = Tools::getValue('submitPing')){

	       $_category = Db::getInstance()->getRow('SELECT `id_category`
		    FROM `'._DB_PREFIX_.'category_product` 
		    WHERE `id_product` = '.intval($_pVal));
	       $alias_category = Db::getInstance()->getRow('SELECT *
	        FROM `'._DB_PREFIX_.'category_lang`
	        WHERE `id_category` = '.intval($_category['id_category']));
	       $_title = Db::getInstance()->getRow('SELECT `name`,`meta_title`,`link_rewrite`	FROM `'._DB_PREFIX_.'product_lang`WHERE `id_product` = '.intval($_pVal));
	   if(!$alias_product = $_title['link_rewrite'])
		{
		   $_pUrl = _PS_BASE_URL_.__PS_BASE_URI__.'product.php?id_product='.intval($_pVal);	
			}
			  else
                   $_pUrl = (_PS_BASE_URL_.__PS_BASE_URI__.$alias_category['link_rewrite'].'/').intval($_pVal).'-'.$alias_product.'.html';
            
    //  foreach($_title AS $row)
	//  if (intval($row['id_lang']) == intval($cookie->id_lang)) 
	//	{   
		  if(!$$_title['meta_title'])$_pTitle = $_title['name'];
			  else $_pTitle = $_title['meta_title'];
		//	break;
		//	}

	        $blogpost = array("title" => $_pTitle, "postlink" => $_pUrl);
	       $yes = 0;
	        echo'<div class="module_confirmation conf confirm">'.$this->l('Ping for product: ').$blogpost['title'].' ('.$blogpost['postlink'].')'.'</div>';
      if(count($this->_pingservers)>0)
        {   
			foreach ( $this->_pingservers as $_server )
			{
			$msg="PingService: ".$_server." - <";
			$response=$this->_pingServer($_server, $blogpost);
				
			switch($response[0]){
					
					case 0: 
					    echo'<div class="module_confirmation conf confirm">
				<img src="../img/admin/ok.gif" alt="" title="" style="margin-right:5px; float:left;" />
				'.$msg.$response[0].'> - '.$response[1].'
			</div>';
					$yes = 1;
					
//	$this->_done[] = $_pVal;
//  Configuration::updateValue('PING_DONE', implode(',',$this->_done));
						break;
					case 1: 
						echo'<div class="alert error">
				<img src="../img/admin/forbbiden.gif" alt="" title="" style="margin-right:5px; float:left;" />
				'.$msg.$response[0].'> - '.$response[1].'
			</div>';
						break;
					default:
					    echo'<div class="warning warn">
				<img src="../img/admin/warning.gif" alt="" title="" style="margin-right:5px; float:left;" />
				'.$msg.$response[0].'> - '.$response[1].'
			</div>';
						break;
				}	
			}	
		  }else{
						echo'<div class="alert error">
				<img src="../img/admin/forbbiden.gif" alt="" title="" style="margin-right:5px; float:left;" />'.$this->l('Ping not sent, since no pingserver is specified in the BlogPing settings!').'
			</div>';
	}
	
	if($yes != 0)
		{	
 	$upd = Configuration::get('PING_DONE').','.$_pVal;
    Configuration::updateValue('PING_DONE',$upd );
		}
	//	echo $_msg;
		}
	}

   /**
	 * This method makes a connection to the ping server and returns any errorcode occured.
	 * 
	 * @access private
	 * @author Daniel Eliasson
	 * @modified by ramzes_ra
	 */
    private function _pingServer($URL, $blogpost)
	{
	
    $parse = parse_url($URL);
	if(!isset($parse['host'])) return false;
		$host = $parse['host'];
		$port = isset($parse['port'])?$parse['port']:80;
		$uri  = isset($parse['path'])?$parse['path']:'/';
	
		$fp=fsockopen($host,$port,$errno,$errstr);
	if(!$fp){

		return array(1,"Cannot open connection.<br />\n");		
		}
		$data = "<?xml version=\"1.0\"?>\r\n
		<methodCall>\r\n
  			<methodName>weblogUpdates.ping</methodName>\r\n
	  		<params>\r\n
	    		<param>\r\n
	      			<value>".$blogpost['title']."</value>\r\n
	    		</param>\r\n
	    		<param>\r\n
	      			<value>".$blogpost['postlink']."</value>\r\n
	    		</param>\r\n
	  		</params>\r\n
		</methodCall>";

		$len  = strlen($data);
		$out  = "POST $uri HTTP/1.0\r\n";
		$out .= "User-Agent: BlogPing/1.0\r\n";
		$out .= "Host: $host\r\n";
		$out .= "Content-Type: text/xml\r\n";
		$out .= "Content-length: $len\r\n\r\n";
		$out .= $data;

		fwrite($fp, $out);
		$response = '';
		while(!feof($fp)) $response.=fgets($fp, 128);
		fclose($fp);

		$lines=explode("\r\n",$response);
		$firstline=$lines[0];
		if(!ereg("HTTP/1.[01] 200 OK",$firstline))
		{	
			return array(-1,$firstline);	
		}
       
		while($lines[0]!='') array_shift($lines);
		array_shift($lines);
		$lines=strip_tags(implode(' ',$lines));
		

	/*	$n=preg_match('|<member>\s*<name>flerror</name>\s*<value>\s*<boolean>([^<]*)</boolean>\s*</value>\s*</member>|i',
		$lines, $matches);
		if(0==$n)*/
		if(!$flerr = strstr ($response, 'flerror'))
		{	return array(-1,$lines);	}
		else
		{
			if(strstr ($flerr, 'flerror ')) $flerror= substr($flerr,8,1);
				else
		$flerror= substr($flerr,7,1);
		}
	/*	$n=preg_match('|<member>\s*<name>message</name>\s*<value>\s*<string>([^<]*)</string>\s*</value>\s*</member>|i',
		$lines, $matches);
		if(0==$n)*/
			if(!$mess = strstr ($response, 'message'))
		{	return array(-1,$lines);	}
		$message=substr($mess,7);

		return array($flerror,$message);
	}
}

?>
